#include <stdio.h>

struct sNo
{
    int         Info;
    struct sNo* Prox;
}* Inicio;

struct sNo* Insira (struct sNo* Inicio, int Numero)
{
    if (Inicio == NULL)
    {
	struct sNo* Novo = (struct sNo*) malloc (sizeof (struct sNo));

	Novo -> Info = Numero;
	Novo -> Prox = NULL;

	return Novo;
    }
    else
	if (Numero < Inicio -> Info)
	{
	    struct sNo* Novo = (struct sNo*) malloc (sizeof (struct sNo));

	    Novo -> Info = Numero;
	    Novo -> Prox = Inicio;

	    return Novo;
	}
	else
	{
	    Inicio -> Prox = Insira (Inicio -> Prox, Numero);
	    return Inicio;
	}
}

struct sNo* Remova (struct sNo* Inicio, int Numero)
{
    if (Inicio == NULL)
	return Inicio;
    else
	if (Inicio -> Info == Numero)
	{
	    struct sNo* Removido = Inicio;
	    Inicio = Inicio -> Prox;
	    free (Removido);
	    return Remova (Inicio, Numero);
	}
	else
	{
	    Inicio -> Prox = Remova (Inicio -> Prox, Numero);
	    return Inicio;
	}
}

void Imprima (struct sNo* Inicio)
{
    if (Inicio == NULL)
	printf ("{}\n");
    else
    {
	printf ("{");

	for (; Inicio != NULL; Inicio = Inicio -> Prox)
	    printf ("%d, ", Inicio -> Info);

	printf ("\b\b}\n");
    }
}

void Insersao ()
{
    int Numero;

    printf ("Entre com o inteiro a inserir: ");
    scanf  ("%d", &Numero);

    Inicio = Insira (Inicio, Numero);
}

void Remocao ()
{
    int Numero;

    printf ("Entre com o inteiro a remover: ");
    scanf  ("%d", &Numero);

    Inicio = Remova (Inicio, Numero);
}

void Impressao ()
{
    Imprima (Inicio);
}

void Termino ()
{
    exit (0);
}

void main ()
{
    static void (*Funcao [4]) () = {&Insersao, &Remocao, &Impressao, &Termino};
    int Opcao;

    for (;;)
    {
	printf ("\nOpcao (0=Insercao/1=Remocao/2=Impressao/3=Termino): ");
	scanf ("%d", &Opcao);
	(*Funcao [Opcao]) ();
    }
}
